package main

import (
  "fmt"
  "os"
)

func anag(s string) map[string]bool {
  if len(s) == 0 {
    return map[string]bool{"": true}   // Insieme che contiene solo la stringa buota
  }
  var res map[string]bool
  res = make(map[string]bool)
  // Esempio: "cane"
  for i := 0; i < len(s); i++ {
    primaLettera := string(s[i])   // Prima lettera dell'anagramma, es. "n"
    resto := s[:i] + s[i+1:]       // Resto della parola, es. "ca" + "e"
    z := anag(resto)               // Anagrammi di "cae"
    for x, _ := range z {
      res[primaLettera + x] = true  // Aggiungo "n" davanti
    }
  }
  return res
}


func main() {
  insiemeAnagrammi := anag(os.Args[1])
  for x, _ := range insiemeAnagrammi {
    fmt.Printf("%s ", x)
  }
  fmt.Println()
}
