package main

import (
  "fmt"
  "os"
)

func anag(s string) []string {
  if len(s) == 0 {
    return []string{""}
  }
  var res []string
  // Esempio: "cane"
  for i := 0; i < len(s); i++ {
    primaLettera := string(s[i])   // Prima lettera dell'anagramma, es. "n"
    resto := s[:i] + s[i+1:]       // Resto della parola, es. "ca" + "e"
    z := anag(resto)               // Anagrammi di "cae"
    for _, x := range z {
      res = append(res, primaLettera + x)   // Aggiungo "n" davanti
    }
  }
  return res
}


func main() {
  fmt.Println(anag(os.Args[1]))
}
